-- credits to:
-- HopeASD (NGA qfeizaijun)/ 简繁(NGA zhangzhanxian3)
local addonName, addon = ...
addon[1] = {} -- Gloable
addon[2] = {} -- Function
addon[3] = {} -- Config
addon[4] = {} -- Locale

local G, F, C, L = unpack(addon)

local events = {}

local host = CreateFrame("Frame")
host:SetScript("OnEvent", function(_, event, ...)
	for func in pairs(events[event]) do
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			func(event, CombatLogGetCurrentEventInfo())
		else
			func(event, ...)
		end
	end
end)

function G:RegisterEvent(event, func, unit1, unit2)
	if not events[event] then
		events[event] = {}
		if unit1 then
			host:RegisterUnitEvent(event, unit1, unit2)
		else
			host:RegisterEvent(event)
		end
	end

	events[event][func] = true
end

function G:UnregisterEvent(event, func)
	local funcs = events[event]
	if funcs and funcs[func] then
		funcs[func] = nil

		if not next(funcs) then
			events[event] = nil
			host:UnregisterEvent(event)
		end
	end
end

local DefaultDB = {
	cvar = true,
	tiny = true,
	mapicon = true,
	ui = true,
	chat = true,
	comb = true,
	syd = true,
	icon = true,
	unitf = true,
	cast = true,
	chatg = true,
	smap = true,
	mmb = true,
	chatcopy = true,
	chatm = true,
	chatb = true,
	zu = true,
	mh = true,
	sq = true,
	ptexture = false,
	rtexture =false,
	class = false,
	bc = true,
	ftip = 1,
	
}

local eventframe = CreateFrame("Frame")
eventframe:RegisterEvent("ADDON_LOADED")
eventframe:SetScript("OnEvent",function(self,_,addon)
	if addon ~= "AddUI" then return end
	if not AddUIDB then AddUIDB = {} end
	
		for i, j in pairs(DefaultDB) do
		if type(j) == "table" then
			if AddUIDB[i] == nil then AddUIDB[i] = {} end
			for k, v in pairs(j) do
				if AddUIDB[i][k] == nil then
					AddUIDB[i][k] = v
				end
			end
		else
			if AddUIDB[i] == nil then AddUIDB[i] = j end
		end
	end
	self:UnregisterAllEvents()

end)
local function TestFunc()
if AddUIDB["ceshi"] ==  true  then print("测试") end
end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)



local frame1 = CreateFrame("Frame", nil, InterfaceOptionsFrame, "OptionsBoxTemplate")
frame1.name = addonName

--local frame2 = CreateFrame("Frame", "血条", frame1)
--frame2.name = "血条"
--frame2.parent =  frame1

frame1:SetScript("OnShow", function(frame)

	local addui = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	addui:SetPoint("TOPLEFT", 55, -16)
	addui:SetText(addonName)
	addui:SetFont("fonts\\ARHei.ttf", 30, "OUTLINE")
		
	local sm = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	sm:SetPoint("TOPLEFT", 200, -22)
	sm:SetText("重载界面|cff00EE00/aa|r     打开此设置界面|cff00EE00/ad|r\n\n只是一个简单的开关界面,省的去改toc文件了\n|cffFFC0CB需要重载界面才能生效|r,或者退一次游戏\n右击聊天快捷条|cff00EE00世|r按钮可以加入/退出世界频道")
	sm:SetJustifyH("LEFT")
	
	local qqun = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	qqun:SetPoint("BOTTOMRIGHT", -10, 10)
	qqun:SetText("斗鱼:323075\r\rQQ群:718148969")
	qqun:SetJustifyH("RIGHT")
	
	local printhelp = CreateFrame("Button", "AddUISaveButton", frame, "UIPanelButtonTemplate")
	printhelp:SetText("斜杠线命令")
	printhelp:SetWidth(177)
	printhelp:SetHeight(24)
	printhelp:SetPoint("TOPLEFT", 16, -55)
	printhelp:SetScript("OnClick", function()
		StaticPopup_Show("printhelp") 
	end)

	local clear = CreateFrame("Button", "AddUISaveButton", frame, "UIPanelButtonTemplate")
	clear:SetText("重载界面")
	clear:SetWidth(177)
	clear:SetHeight(24)
	clear:SetPoint("TOPLEFT", 16, -85)
	clear:SetScript("OnClick", function()
		ReloadUI()
	end)
	
	local function newCheckbox(label, description, onClick)
		local check = CreateFrame("CheckButton", "AddUICheck" .. label, frame, "InterfaceOptionsCheckButtonTemplate")
		check:SetScript("OnClick", function(self)
			local tick = self:GetChecked()
			onClick(self, tick and true or false)
		end)
		check.label = _G[check:GetName() .. "Text"]
		check.label:SetText(label)
		check.tooltipText = description
		--check.tooltipRequirement = description
		return check
	end

	local cvarc = newCheckbox("CVar-锁定一些系统设定","CVar设定,最远视角和社区报错集合石报错优化",function(self, value) AddUIDB.cvar = value end)
	cvarc:SetChecked(AddUIDB.cvar)
	cvarc:SetPoint("TOPLEFT", 16, -120)

	local tinyc = newCheckbox("其他插件自动配置","每次上线自动勾选同一种配置,",function(self, value) AddUIDB.tiny = value end)
	tinyc:SetChecked(AddUIDB.tiny)
	tinyc:SetPoint("TOPLEFT", 16, -150)
	
	
	local uic = newCheckbox("UI缩放锁定","ESC-系统-高级-最下面那个UI缩放",function(self, value) AddUIDB.ui = value end)
	uic:SetChecked(AddUIDB.ui)
	uic:SetPoint("TOPLEFT", 16, -180)
	
	local chatc = newCheckbox("聊天窗口位置锁定","每次上线重设聊天框位置",function(self, value) AddUIDB.chat = value end)
	chatc:SetChecked(AddUIDB.chat)
	chatc:SetPoint("TOPLEFT", 16, -210)
	
	
	local combc = newCheckbox("进入脱离战斗提示","屏幕中间上方那个进入脱离战斗提示",function(self, value) AddUIDB.comb = value end)
	combc:SetChecked(AddUIDB.comb)
	combc:SetPoint("TOPLEFT", 16, -240)
	
	local sydc = newCheckbox("角色面板耐久","C键面板装备栏下面的耐久度百分比",function(self, value) AddUIDB.syd = value end)
	sydc:SetChecked(AddUIDB.syd)
	sydc:SetPoint("TOPLEFT", 16, -270)
	
	local iconc = newCheckbox("目标标记按钮","目标头像右边的几个标记按钮",function(self, value) AddUIDB.icon = value end)
	iconc:SetChecked(AddUIDB.icon)
	iconc:SetPoint("TOPLEFT", 16, -300)
	

	--[[
	local info = {}
	local TipDropdown = CreateFrame("Frame", "Tipcursor", frame, "UIDropDownMenuTemplate")
	TipDropdown:SetPoint("TOPLEFT", 0, -510)
	TipDropdown.initialize = function()
		wipe(info)
		local fonts = {1, 0, 2}
		local names = {"跟随", "不跟随", "非战斗跟随"}
		for i, font in next, fonts do
			info.text = names[i]
			info.value = font
			info.func = function(self)
				AddUIDB.ftip = self.value
				TipcursorText:SetText(self:GetText())
			end
			info.checked = font == AddUIDB.ftip
			UIDropDownMenu_AddButton(info)
		end
	end
	TipcursorText:SetText("鼠标跟随方式")
	]]
	
	

	
	local unitfc = newCheckbox("头像美化","头像美化和旁边的血量百分比",function(self, value) AddUIDB.unitf = value end)
	unitfc:SetChecked(AddUIDB.unitf)
	unitfc:SetPoint("TOPLEFT", 280, -120)
	
	local castc = newCheckbox("施法条美化","这个施法条是系统自带的去掉了边框放大了",function(self, value) AddUIDB.cast = value end)
	castc:SetChecked(AddUIDB.cast)
	castc:SetPoint("TOPLEFT", 280, -150)
	
	local smapc = newCheckbox("小地图美化","这个关掉的话需要重新进一次游戏才能正常",function(self, value) AddUIDB.smap = value end)
	smapc:SetChecked(AddUIDB.smap)
	smapc:SetPoint("TOPLEFT", 280, -180)
	
	local mmbc = newCheckbox("动作条美化","动作条美化",function(self, value) AddUIDB.mmb = value end)
	mmbc:SetChecked(AddUIDB.mmb)
	mmbc:SetPoint("TOPLEFT", 280, -210)
	
	local chatmc = newCheckbox("聊天窗口美化","聊天窗口美化",function(self, value) AddUIDB.chatm = value end)
	chatmc:SetChecked(AddUIDB.chatm)
	chatmc:SetPoint("TOPLEFT", 280, -240)
	
	local chatbc = newCheckbox("聊天快捷按钮","右击世可以快速加入世界频道!",function(self, value) AddUIDB.chatb = value end)
	chatbc:SetChecked(AddUIDB.chatb)
	chatbc:SetPoint("TOPLEFT", 280, -270)
	
	local zuc = newCheckbox("密语自动邀请","别人密你123或者.组.会自动邀请,支持战网密语",function(self, value) AddUIDB.zu = value end)
	zuc:SetChecked(AddUIDB.zu)
	zuc:SetPoint("TOPLEFT", 280, -300)
	
	local mhc = newCheckbox("自动卖灰","捡破烂自动卖",function(self, value) AddUIDB.mh = value end)
	mhc:SetChecked(AddUIDB.mh)
	mhc:SetPoint("TOPLEFT", 280, -330)
	
	--local bcc = newCheckbox("隐藏动作条边框","如果使用材质建议隐藏",function(self, value) AddUIDB.bc = value end)
	--bcc:SetChecked(AddUIDB.bc)
	--bcc:SetPoint("TOPLEFT", 460, -120)
	

	local sqc = newCheckbox("快速拾取","增加拾取速度",function(self, value) AddUIDB.sq = value end)
	sqc:SetChecked(AddUIDB.sq)
	sqc:SetPoint("TOPLEFT", 460, -120)
	
	local classc = newCheckbox("头像职业图标","用职业图标代替头像",function(self, value) AddUIDB.class = value end)
	classc:SetChecked(AddUIDB.class)
	classc:SetPoint("TOPLEFT", 460, -150)
	
	local rtexturec = newCheckbox("团队扁平材质","团队框架材质扁平化",function(self, value) AddUIDB.rtexture = value end)
	rtexturec:SetChecked(AddUIDB.rtexture)
	rtexturec:SetPoint("TOPLEFT", 460, -180)
	
	
	frame:SetScript("OnShow", nil)
	
	--frame.okay = function(frame)
	--		ReloadUI()
	--end
end)

InterfaceOptions_AddCategory(frame1)
--InterfaceOptions_AddCategory(frame2)
SLASH_ADDUI1 = "/ad"
SLASH_ADDUI2 = "/add"
SLASH_ADDUI3 = "/addui"
SlashCmdList["ADDUI"] = function() 
    InterfaceOptionsFrame_OpenToCategory(frame1)
	InterfaceOptionsFrame_OpenToCategory(frame1)
end